unit suchen1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TIntArray = array[0..2000] of integer;
  TForm1 = class(TForm)
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    edit_anzahl: TEdit;
    edit_grenze: TEdit;
    GroupBox3: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Button6: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    procedure Button6Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Private-Deklarationen }
    sort_feld: TIntArray;
    procedure loescheListBox;
    procedure listBox2Array;
    procedure array2listBox;
    function quicksortfkt(a:TIntArray; l,r:integer):TIntArray;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button6Click(Sender: TObject);
begin
   halt;
end;


procedure TForm1.Button3Click(Sender: TObject);
// Aufruf fuer lineares Suchen
begin
   ShowMessage('Kommt noch :-)');
end;

procedure TForm1.Button4Click(Sender: TObject);
// Aufruf fuer Binres Suchen
begin
  ShowMessage('=> to do!');
end;

procedure TForm1.Button5Click(Sender: TObject);
// Aufruf fuer Quicksort
Var
  anzahl    : integer;
begin
  listBox2Array;
  anzahl := ListBox1.Items.Count - 1;
  sort_feld := quicksortfkt(sort_feld,0,anzahl);
  array2listBox;
end;

procedure TForm1.Button2Click(Sender: TObject);
// Liest die beiden felder Anzahl und Obergrenze azs und erzeugt
// eine Liste von Zufallszahlen in der ListBox
var
  anzahl, ogrenze, index : integer;

begin
      anzahl := strtoint(edit_anzahl.Text);
      if (anzahl <= 0) then anzahl := 1;
      if (anzahl > 2000) then anzahl := 2000;
      anzahl := anzahl - 1; // da Start bei 0 
      ogrenze := strtoint(edit_grenze.Text);
      if (ogrenze <= 0) then ogrenze := 1;
      Randomize;
      loescheListBox;
      for index := 0 to anzahl do
            ListBox1.Items.Add(IntToStr(Random(ogrenze)));
      Label3.caption := 'Item.Count: ' + inttostr(anzahl+1); //: ListBox1.Items[ListBox1.ItemIndex];
end;


procedure TForm1.Button1Click(Sender: TObject);
// lscht ListBox
begin
    loescheListBox;
end;

procedure TForm1.loescheListBox;
// lscht ListBox
var
  i: integer;
begin
  Label3.caption := 'Item.Count: 0';
  for i := ListBox1.Items.Count - 1 downto 0 do
      ListBox1.Items.Delete(i);
end;

function TForm1.quicksortfkt(a:TIntArray; l,r:integer):TIntArray;
// Quicksort: rekursive Sortierfunktion
var
  i,j,k,pivot,temp:integer;
begin
  if l<r then begin
    i:=l; j:=r;
    k:=(l+r) div 2;   // Index k in der Mitte
    pivot:=a[k];      // Element an der Position k
    repeat
      // die folgenden beiden Schleifen vergleichen
      // die Elemente links mit dem Pivot-Element
      while a[i]<pivot do inc(i);
      // bzw. die Elemente rechts mit dem Pivot-Element
      while pivot<a[j] do dec(j);
      // dabei wandert der Zeiger i von links nach rechts
      // und der Zeiger j von rechts nach links
      ////////////////////////////////////////////
      // Jetzt liegt folgende Situation vor:
      // das Element  a[i]>=pivot und das Element a[j]<=pivot
      // also tauschen wir die beiden Elemente
      if i<=j then begin
        // tauschen!!!
        temp:=a[i];
        a[i]:=a[j];
        a[j]:=temp;
        inc(i);
        dec(j);
       end;
       // die Schleife endet, wenn der linke Zeiger i grer ist als der rechte Zeiger j => Bild!
     until i>=j;
     // da jetzt i>=j, bezeichnet der Zeiger j das rechte Ende der linken Hlfte
     // und der Zeiger i den linken Anfang der rechten Hlfte
     ///////////////////////////////////////////////////////////
     // rekursiver Aufruf fuer linke Haelfte von l bis j
     a:=quicksortfkt(a,l,j);
     // rekursiver Aufruf fuer rechte Haelfte von i bis r
     a:=quicksortfkt(a,i,r);
  end;
  quicksortfkt:=a;
end;

procedure TForm1.listBox2Array;
var
  i         : integer;
  anzahl    : integer;
begin
  anzahl := ListBox1.Items.Count - 1;
  for i:= 0 to anzahl do sort_feld[i] := StrToInt(ListBox1.Items[i]);
end;

procedure TForm1.array2listBox;
var
  i         :integer;
  anzahl    : integer;
begin
  anzahl := ListBox1.Items.Count - 1;
  for i:= 0 to anzahl do ListBox1.Items[i] := IntToStr(sort_feld[i]);
end;


end.
